{
    "$graph": [
        {
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bio-client:latest"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 2000,
                    "ramMax": 2000,
                    "tmpdirMin": "$(Math.ceil (inputs.file_size / 1048576))",
                    "tmpdirMax": "$(Math.ceil (inputs.file_size / 1048576))",
                    "outdirMin": "$(Math.ceil (inputs.file_size / 1048576))",
                    "outdirMax": "$(Math.ceil (inputs.file_size / 1048576))"
                }
            ],
            "inputs": [
                {
                    "id": "#bio_client_download.cwl/config-file",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-c",
                        "position": 0
                    }
                },
                {
                    "id": "#bio_client_download.cwl/dir_path",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "--dir_path",
                        "position": 99
                    }
                },
                {
                    "id": "#bio_client_download.cwl/download",
                    "type": "string",
                    "default": "download",
                    "inputBinding": {
                        "position": 1
                    }
                },
                {
                    "id": "#bio_client_download.cwl/download_handle",
                    "type": "string",
                    "inputBinding": {
                        "position": 98
                    }
                },
                {
                    "id": "#bio_client_download.cwl/file_size",
                    "type": "long",
                    "default": 1
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bio_client.py"
            ],
            "id": "#bio_client_download.cwl",
            "outputs": [
                {
                    "id": "#bio_client_download.cwl/output",
                    "type": "File",
                    "outputBinding": {
                        "glob": "*"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/fastq-to-sam-pu:455c68b6b3345f7c0c1e7d21430da82a270560f874489e9059e28cf3cac20612"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#fastq-to-sam-pu.cwl/fastq_path",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "--fastq_path"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#fastq-to-sam-pu.cwl/output",
                    "type": "string",
                    "outputBinding": {
                        "glob": "$(inputs.fastq_path.nameroot).pu.out",
                        "loadContents": true,
                        "outputEval": "$(self[0].contents.trim())"
                    }
                }
            ],
            "stdout": "$(inputs.fastq_path.nameroot).pu.out",
            "baseCommand": [
                "/usr/local/bin/fastq_to_SAM_PU"
            ],
            "id": "#fastq-to-sam-pu.cwl"
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/picard:092d034713aff237cf07ef28c22a46a113d1a59dc7ec6d71beb72295044a46f8"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 10000,
                    "ramMax": 10000,
                    "tmpdirMin": "$(Math.ceil(1.1 * inputs.FASTQ.size / 1048576))",
                    "tmpdirMax": "$(Math.ceil(1.1 * inputs.FASTQ.size / 1048576))",
                    "outdirMin": "$(Math.ceil(1.1 * inputs.FASTQ.size / 1048576))",
                    "outdirMax": "$(Math.ceil(1.1 * inputs.FASTQ.size / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#picard_fastqtosam_se.cwl/FASTQ",
                    "type": "File",
                    "format": "#picard_fastqtosam_se.cwl/format_2182",
                    "inputBinding": {
                        "prefix": "FASTQ=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/READ_GROUP_NAME",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "READ_GROUP_NAME=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/SAMPLE_NAME",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "SAMPLE_NAME=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/LIBRARY_NAME",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "LIBRARY_NAME=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/PLATFORM_UNIT",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "PLATFORM_UNIT=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/PLATFORM",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "PLATFORM=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/SEQUENCING_CENTER",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "SEQUENCING_CENTER=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/PREDICTED_INSERT_SIZE",
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "PREDICTED_INSERT_SIZE=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/PROGRAM_GROUP",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "PROGRAM_GROUP=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/PLATFORM_MODEL",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "PLATFORM_MODEL=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/COMMENT",
                    "type": [
                        "null",
                        {
                            "type": "array",
                            "items": "string",
                            "inputBinding": {
                                "prefix": "COMMENT=",
                                "separate": false
                            }
                        }
                    ]
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/DESCRIPTION",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "DESCRIPTION=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/RUN_DATE",
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "RUN_DATE=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/SORT_ORDER",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/SORT_ORDER/unsorted",
                                "#picard_fastqtosam_se.cwl/SORT_ORDER/queryname",
                                "#picard_fastqtosam_se.cwl/SORT_ORDER/coordinate",
                                "#picard_fastqtosam_se.cwl/SORT_ORDER/duplicate",
                                "#picard_fastqtosam_se.cwl/SORT_ORDER/unknown"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "SORT_ORDER=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/MIN_Q",
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "MIN_Q=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/MAX_Q",
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "MAX_Q=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/ALLOW_AND_IGNORE_EMPTY_LINES",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/ALLOW_AND_IGNORE_EMPTY_LINES/true",
                                "#picard_fastqtosam_se.cwl/ALLOW_AND_IGNORE_EMPTY_LINES/false"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "ALLOW_AND_IGNORE_EMPTY_LINES=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/TMP_DIR",
                    "default": ".",
                    "type": "string",
                    "inputBinding": {
                        "prefix": "TMP_DIR=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/VERBOSITY",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/VERBOSITY/ERROR",
                                "#picard_fastqtosam_se.cwl/VERBOSITY/WARNING",
                                "#picard_fastqtosam_se.cwl/VERBOSITY/INFO",
                                "#picard_fastqtosam_se.cwl/VERBOSITY/DEBUG"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "VERBOSITY=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/QUIET",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/QUIET/true",
                                "#picard_fastqtosam_se.cwl/QUIET/false"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "QUIET=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/VALIDATION_STRINGENCY",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/VALIDATION_STRINGENCY/STRICT",
                                "#picard_fastqtosam_se.cwl/VALIDATION_STRINGENCY/LENIENT",
                                "#picard_fastqtosam_se.cwl/VALIDATION_STRINGENCY/SILENT"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "VALIDATION_STRINGENCY=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/COMPRESSION_LEVEL=",
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "COMPRESSION_LEVEL=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/MAX_RECORDS_IN_RAM",
                    "type": [
                        "null",
                        "long"
                    ],
                    "inputBinding": {
                        "prefix": "MAX_RECORDS_IN_RAM=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/CREATE_INDEX",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/CREATE_INDEX/true",
                                "#picard_fastqtosam_se.cwl/CREATE_INDEX/false"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "CREATE_INDEX=",
                        "separate": false
                    }
                },
                {
                    "id": "#picard_fastqtosam_se.cwl/CREATE_MD5_FILE",
                    "type": [
                        "null",
                        {
                            "type": "enum",
                            "symbols": [
                                "#picard_fastqtosam_se.cwl/CREATE_MD5_FILE/true",
                                "#picard_fastqtosam_se.cwl/CREATE_MD5_FILE/false"
                            ]
                        }
                    ],
                    "inputBinding": {
                        "prefix": "CREATE_MD5_FILE=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#picard_fastqtosam_se.cwl/OUTPUT",
                    "type": "File",
                    "format": "#picard_fastqtosam_se.cwl/format_2572",
                    "outputBinding": {
                        "glob": "$(inputs.READ_GROUP_NAME).bam"
                    }
                }
            ],
            "arguments": [
                {
                    "valueFrom": "$(inputs.READ_GROUP_NAME).bam",
                    "prefix": "OUTPUT=",
                    "separate": false
                }
            ],
            "baseCommand": [
                "java",
                "-jar",
                "/usr/local/bin/picard.jar",
                "FastqToSam"
            ],
            "id": "#picard_fastqtosam_se.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readgroup_no_pu.yaml/readgroup_meta",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/DT",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/ID",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/LB",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/PM",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/PU",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/SM",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/flow_cell_barcode",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/lane_number",
                                    "type": [
                                        "null",
                                        "long"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/multiplex_barcode",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/capture_kit_bait_uuid",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_meta/caputre_kit_target_uuid",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                }
                            ]
                        },
                        {
                            "name": "#readgroup_no_pu.yaml/readgroup_fastq_pe",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_pe/readgroup_meta",
                                    "type": "#readgroup_no_pu.yaml/readgroup_meta"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_pe/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_pe/forward_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_pe/reverse_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_pe/reverse_fastq_file_size",
                                    "type": "long"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup_no_pu.yaml/readgroup_fastq_se",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_se/readgroup_meta",
                                    "type": "#readgroup_no_pu.yaml/readgroup_meta"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_se/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroup_fastq_se/forward_fastq_file_size",
                                    "type": "long"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup_no_pu.yaml/readgroups_bam",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroups_bam/bam_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroups_bam/bam_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup_no_pu.yaml/readgroups_bam/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup_no_pu.yaml/readgroup_meta"
                                    }
                                }
                            ]
                        }
                    ],
                    "id": "#readgroup_no_pu.yaml"
                },
                {
                    "class": "StepInputExpressionRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/bioclient_config",
                    "type": "File"
                },
                {
                    "id": "#main/readgroup_fastq_se",
                    "type": "#readgroup_no_pu.yaml/readgroup_fastq_se"
                }
            ],
            "outputs": [
                {
                    "id": "#main/output_bam",
                    "type": "File",
                    "outputSource": "#main/picard_fastqtosam_se/OUTPUT"
                }
            ],
            "steps": [
                {
                    "id": "#main/extract_forward_fastq",
                    "run": "#bio_client_download.cwl",
                    "in": [
                        {
                            "id": "#main/extract_forward_fastq/config-file",
                            "source": "#main/bioclient_config"
                        },
                        {
                            "id": "#main/extract_forward_fastq/download_handle",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.forward_fastq_uuid)"
                        },
                        {
                            "id": "#main/extract_forward_fastq/file_size",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.forward_fastq_file_size)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/extract_forward_fastq/output"
                        }
                    ]
                },
                {
                    "id": "#main/emit_pu",
                    "run": "#fastq-to-sam-pu.cwl",
                    "in": [
                        {
                            "id": "#main/emit_pu/fastq_path",
                            "source": "#main/extract_forward_fastq/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/emit_pu/output"
                        }
                    ]
                },
                {
                    "id": "#main/picard_fastqtosam_se",
                    "run": "#picard_fastqtosam_se.cwl",
                    "in": [
                        {
                            "id": "#main/picard_fastqtosam_se/FASTQ",
                            "source": "#main/extract_forward_fastq/output"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/READ_GROUP_NAME",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta.ID)"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/SAMPLE_NAME",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta.SM)"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/LIBRARY_NAME",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta.LB)"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/PLATFORM_UNIT",
                            "source": "#main/emit_pu/output"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/PLATFORM",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta.PL)"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/SEQUENCING_CENTER",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta.CN)"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/RUN_DATE",
                            "source": "#main/readgroup_fastq_se",
                            "valueFrom": "$(self.readgroup_meta.DT)"
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/MAX_RECORDS_IN_RAM",
                            "default": 500000
                        },
                        {
                            "id": "#main/picard_fastqtosam_se/CREATE_INDEX",
                            "valueFrom": "false"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/picard_fastqtosam_se/OUTPUT"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
